﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace UnbalancedMatchSim
{
    class NegativeCorrelationUtility : IUtility
    {

        private int numMen;
        private int numWomen;

        private double[,] espsilon_draws;


        // initiates the utility model and draws eps_ij for each man i and woman j
        public NegativeCorrelationUtility(int numMen, int numWomen)
        {
            this.numMen = numMen;
            this.numWomen = numWomen;
            espsilon_draws = new double[numMen,numWomen]; 

            for (int i = 0; i < numMen; i++)
			{
                for (int j = 0; j < numWomen; j++)
                {
                    espsilon_draws[i,j] = PrefGenerator.r.NextDouble();
                }
			}
        }



        ICharacteristics IUtility.drawChar(int K, bool isMen)
        {
            return null;
        }

        double IUtility.drawUtil(int agentIndex, int spouseIndex, ICharacteristics characteristicsSpouses, ICharacteristics mySideCharestaristics, bool isMen)
        {
            if (isMen)
            {
                return espsilon_draws[agentIndex, spouseIndex];
            }
            else
            {
                return -espsilon_draws[spouseIndex, agentIndex];
            }
        }

        double IUtility.getUnmatchedUtil(int agentIndex, ICharacteristics characteristicsSpouses, ICharacteristics mySideCharestaristics, bool isMen)
        {
            return Double.NegativeInfinity;
        }

        void IUtility.setCoefficient(string coefficientName, double value)
        {
            throw new NotImplementedException();
        }

        void IUtility.setParam(string paramName, int value)
        {
            throw new NotImplementedException();
        }

        void IUtility.writeCoefficients(System.IO.StreamWriter sw)
        {
            sw.Write("NoCoeff");
        }

        void IUtility.writeUtilityModelDescrition(System.IO.StreamWriter sw)
        {
            sw.Write("Men's utility is eps_ij. Women's is -eps_ij. With eps_ij drawn U[0,1].");
        }
    }
}
