﻿// PrefGenerator.cs
// A utility class for generating permutations
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace UnbalancedMatchSim
{
    /// <summary>
    /// This class inludes function that generate random permutations (for drawing IID preferences).
    /// </summary>
    public class PrefGenerator
    {
        public static Random r = new Random();


        public static double getExremeValDraw()
        {
            return -Math.Log(-Math.Log(r.NextDouble()));
        }

        /* Generates an array which is a uniformly random permutation of 0..n-1
         * 
         */
        public static int[] getPermutation(int n)
        {
            // Create array with the element 1..n
            int[] res = new int[n];
            for (int i = 0; i < n; i++)
            {
                res[i] = i;
            }

            //randomly permute each coordinate

            for (int i = 0; i < n; i++)
            {
                //draw a random element from res[i],..,res[n-1] (the yet unchosen elements) and put it in res[i]
                int ind = i + r.Next(n - i);
                //switch res[i] and res[ind]
                int temp = res[i];
                res[i] = res[ind];
                res[ind] = temp;
            }

            return res;

        }
        
    }
}
